(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('ibm-wch-sdk-utils')) :
	typeof define === 'function' && define.amd ? define('ibm-wch-sdk-theme', ['exports', 'ibm-wch-sdk-utils'], factory) :
	(factory((global['ibm-wch-sdk-theme'] = {}),global['ibm-wch-sdk-utils']));
}(this, (function (exports,ibmWchSdkUtils) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */










function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function rgbaToHsla(rgb) {
    var r = rgb.r / 255, g = rgb.g / 255, b = rgb.b / 255;
    var max = Math.max(r, g, b), min = Math.min(r, g, b);
    var l = (max + min) / 2;
    var h, s;
    if (max == min) {
        h = s = 0;
    }
    else {
        var d = max - min;
        s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
        switch (max) {
            case r:
                h = (g - b) / d + (g < b ? 6 : 0);
                break;
            case g:
                h = (b - r) / d + 2;
                break;
            case b:
                h = (r - g) / d + 4;
                break;
        }
        h /= 6;
    }
    return { h: h, s: s, l: l, a: rgb.a };
}
function rgbaToString(rgb) {
    return "rgba(" + rgb.r + ", " + rgb.g + ", " + rgb.b + ", " + rgb.a + ")";
}
var colorValue = function (aKey, aColor) {
    return (_a = {}, _a["--" + aKey] = rgbaToString(aColor), _a);
    var _a;
};
var BLACK = { r: 0, g: 0, b: 0, a: 1 };
var noParser = function (color) { return BLACK; };
var colorParser = function (aDoc) {
    if (ibmWchSdkUtils.isNil(aDoc)) {
        return noParser;
    }
    var cvs = aDoc.createElement('canvas');
    cvs.height = 1;
    cvs.width = 1;
    var ctx = cvs.getContext('2d');
    return function (aColor) {
        try {
            ctx.fillStyle = aColor;
            ctx.fillRect(0, 0, 1, 1);
            var res = ctx.getImageData(0, 0, 1, 1).data;
            return {
                r: res[0], g: res[1], b: res[2], a: res[3] / 255
            };
        }
        catch (error) {
            return BLACK;
        }
    };
};
var decomposeColor = function (aKey, aColor) {
    var hsla = rgbaToHsla(aColor);
    return _a = {}, _a["--" + aKey + "-r"] = aColor.r, _a["--" + aKey + "-g"] = aColor.g, _a["--" + aKey + "-b"] = aColor.b, _a["--" + aKey + "-h"] = hsla.h * 360, _a["--" + aKey + "-s"] = hsla.s, _a["--" + aKey + "-l"] = hsla.l, _a["--" + aKey + "-a"] = aColor.a, _a;
    var _a;
};
var colorVariations = function (aKey, aColor) { return (Object.assign({}, colorValue(aKey, aColor), decomposeColor(aKey, aColor))); };
var colorToRGBA = ibmWchSdkUtils.identity;
var colorToHSLA = rgbaToHsla;
var COLOR_SUFFIX = 'Color';
var _colorName = function (name) { return name.substr(0, name.length - COLOR_SUFFIX.length); };
var stylesFromRenderingContext = function (aRenderingContext, aParser) {
    var colors = aRenderingContext.text || {};
    return Object.assign.apply(Object, __spread([{}], Object.keys(colors)
        .filter(function (name) { return name.endsWith(COLOR_SUFFIX); })
        .map(function (name) { return colorVariations(_colorName(name), aParser(colors[name])); })));
};

exports.colorParser = colorParser;
exports.colorVariations = colorVariations;
exports.colorToRGBA = colorToRGBA;
exports.colorToHSLA = colorToHSLA;
exports.stylesFromRenderingContext = stylesFromRenderingContext;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ibm-wch-sdk-theme.umd.js.map
