import { UnaryFunction } from 'rxjs/interfaces';
import { Styles } from './../styles';
export interface HSLA {
    h: number;
    s: number;
    l: number;
    a: number;
}
export interface RGBA {
    r: number;
    g: number;
    b: number;
    a: number;
}
export declare type ColorParser = UnaryFunction<string, RGBA>;
/**
 * Constructs a function that parses a color value using the DOM APIs
 *
 * @param aDoc the document
 * @return the parser function
 */
export declare const colorParser: UnaryFunction<Document, ColorParser>;
export declare const colorVariations: (aKey: string, aColor: RGBA) => Styles;
export declare const colorToRGBA: UnaryFunction<RGBA, RGBA>;
export declare const colorToHSLA: UnaryFunction<RGBA, HSLA>;
