import { UnaryFunction } from 'rxjs/interfaces';
import { RenderingContext } from './../../api';
import { RGBA } from './../colors';
import { Styles } from './../styles';
/**
 * Derives styles based on a rendering context assuming that the contet represents a theme configuration. Color names
 * are expected to be represented as elements of type 'text'. The element label has to end with the term 'Color', the prefix
 * will be the name of the actual CSS color variable (e.g. 'primaryColor').
 *
 * @param aRenderingContext the rendering context of the theme
 *
 * @return a styles object with the computed styles
 */
export declare const stylesFromRenderingContext: (aRenderingContext: RenderingContext, aParser: UnaryFunction<string, RGBA>) => Styles;
